package webis;

import java.sql.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import org.apache.xerces.parsers.SAXParser;

/**
 * Insert the type's description here.
 * Creation date: (24.01.2001 13:33:36)
 * @author: 
 */
public class Xml2db {
	public java.sql.PreparedStatement newDocStatement;
	public java.sql.Connection connection;

	class Handler extends org.xml.sax.helpers.DefaultHandler {
		Object docid;
		public long nextkey = 0;
		public int parent = -1;
		public java.util.Stack elementStack = new java.util.Stack();

		public java.sql.PreparedStatement insertStatement;
		public java.sql.PreparedStatement attribStatement;
		public java.sql.PreparedStatement connectStatement;
		public java.sql.PreparedStatement dataStatement;
		public java.sql.PreparedStatement getTagIDStatement;
		public Handler(Object docid) {
			this.docid = docid;
			try {
				insertStatement = connection.prepareStatement("INSERT INTO FABIAN_TAG VALUES (FABIAN_TAG_SEQ.NEXTVAL,?, ?)");
				getTagIDStatement = connection.prepareStatement("SELECT FABIAN_TAG_SEQ.CURRVAL FROM DUAL");
				attribStatement = connection.prepareStatement("INSERT INTO FABIAN_ATTR VALUES (FABIAN_TAG_SEQ.CURRVAL,?,?)");
				connectStatement = connection.prepareStatement("INSERT INTO FABIAN_PTR VALUES (?, FABIAN_TAG_SEQ.CURRVAL)");
				dataStatement =  connection.prepareStatement("INSERT INTO FABIAN_DATA VALUES (FABIAN_TAG_SEQ.CURRVAL, ?)");
			} catch (SQLException sqle) { 
				System.out.println("Handler()" + sqle);
			}
		}
		/**
		 * Insert the method's description here.
		 * Creation date: (24.01.2001 15:58:43)
		 * @param ch char[]
		 * @param start int
		 * @param length int
		 * @exception org.xml.sax.SAXException The exception description.
		 */
		public void characters(char[] ch, int start, int length) throws org.xml.sax.SAXException {
			try {
				String s = new String(ch, start, length);
				dataStatement.setObject(1, s);
				dataStatement.execute();
			} catch (SQLException sqle) { 
				System.out.println("characters()" + sqle);
			}
		}
		
		/**
		 * Insert the method's description here.
		 * Creation date: (24.01.2001 15:45:43)
		 * @param namespaceURI java.lang.String
		 * @param localName java.lang.String
		 * @param qName java.lang.String
		 * @exception org.xml.sax.SAXException The exception description.
		 */
		public void endElement(String namespaceURI, String localName, String qName) throws org.xml.sax.SAXException {
			elementStack.pop();
		}
		
		/**
		 * Insert the method's description here.
		 * Creation date: (24.01.2001 15:53:33)
		 * @param atts org.xml.sax.Attributes
		 */
		public void insertAttributes(Attributes atts) {
			Object parent = elementStack.peek();
			for (int i = 0; i < atts.getLength(); i++) {
				try {
					attribStatement.setObject(1, atts.getQName(i));
					attribStatement.setObject(2, atts.getValue(i));
					attribStatement.executeUpdate();
				} catch (SQLException sqle) {
					System.out.println("insertAttributes()" + sqle);
				}
			}	
		}
		/**
		 * Insert the method's description here.
		 * Creation date: (24.01.2001 15:29:31)
		 * @param name java.lang.String
		 * @param attrs org.xml.sax.AttributeList
		 * @exception org.xml.sax.SAXException The exception description.
		 */
		public void startElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName, Attributes atts) throws org.xml.sax.SAXException {
			Object parent = null;
			if (elementStack.size() != 0)
				parent = elementStack.peek();
			   
			try {
				// Prepare insert (docid, tagname)
				insertStatement.setObject(1, docid);
				insertStatement.setObject(2, qName);
				// insert
				insertStatement.executeUpdate();
				// get TagID
				ResultSet rs = getTagIDStatement.executeQuery();
				// Put on Stack as parent for all children
				rs.next();
				elementStack.push(rs.getObject(1));
					
				if (parent != null) {
					// Prepare (parent->Currval)
					connectStatement.setObject(1, parent);
					// insert
					connectStatement.executeUpdate();
				}
				insertAttributes(atts);
				
			} catch (SQLException sqle) { 
				System.out.println("startElement() " + sqle.getMessage());
				nextkey--;
			}
			
		}

	}



	/**
	 * Xml2db constructor comment.
	 */
	public Xml2db() {
		super();
	}
	/**
	 * Xml2db constructor comment.
	 */
	public Xml2db(Connection con) {
		this();
		this.connection = con;
		try {
			newDocStatement = con.prepareStatement("INSERT INTO FABIAN_DOC VALUES (FABIAN_DOC_SEQ.NEXTVAL, ?) ");		  
		} catch (SQLException sqle) { 
			System.out.println("Xml2Db() " + sqle.getMessage());
		}
	}
	/**
	 * Starts the application.
	 * @param args an array of command-line arguments
	 */
public static void main(java.lang.String[] args) {
	Connection connection;
	Xml2db xml2db;
	try {
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
		} catch(ClassNotFoundException e) {
			System.out.println("Class.forName : " + e.getMessage());
			System.exit(-1);
		}
		try {
			System.out.println("Connecting");
			connection = DriverManager.getConnection("jdbc:oracle:thin:@darwin.inf.fu-berlin.de:1523:INTRODBS","dbs21","dbs21");

			System.out.println("Creating parser");
			xml2db = new Xml2db(connection);
			System.out.println("Parsing");
			xml2db.parseFile(args[0]);
			connection.close();
		} catch (SQLException sqle) {
			System.out.println("DriverManager.getConnection : " + sqle.getMessage());
			System.exit(-2);
		}
	} catch (SAXParseException saxe) {
		System.out.println(saxe);
		System.out.println("PubID:\t" + saxe.getPublicId());
		System.out.println("SysID:\t" + saxe.getSystemId());
		System.out.println("Line:\t" + saxe.getLineNumber());
		System.out.println("Col:\t" + saxe.getColumnNumber());
	} catch (Exception e) {
		System.out.println(e);
	}
}



/**
 * Insert the method's description here.
 * Creation date: (24.01.2001 15:19:30)
 * @param r java.io.Reader
 */
public void parseFile(String url) throws SAXException, java.io.IOException {
	System.out.println("Opening file");
	java.io.FileInputStream fis = new java.io.FileInputStream(url);
	java.io.InputStreamReader isr = new java.io.InputStreamReader(fis, "utf-8");
	try {
		newDocStatement.setObject(1, url);
		newDocStatement.execute();
		Statement s = connection.createStatement();
		ResultSet rs = s.executeQuery("SELECT FABIAN_DOC_SEQ.CURRVAL FROM dual");
		if (rs.next()) {
			SAXParser saxParser = new SAXParser();
			try {
				saxParser.setFeature("http://xml.org/sax/features/validation", true);
				saxParser.setFeature("http://apache.org/xml/features/continue-after-fatal-error", true);

			} catch (SAXException saxe) {
				System.out.println("parseFile() " + saxe);
				
			}
			saxParser.setContentHandler(new Handler(rs.getObject(1)));
			saxParser.parse(new InputSource(isr));
		}
	} catch (SQLException sqle) {
		System.out.println("parseFile() " + sqle);
	}
}

}
